using System.Runtime.InteropServices;
using Microsoft.VisualStudio.Package;
using Microsoft.VisualStudio.TextManager.Interop;

namespace at.jku.ssw.Coco.VSPlugin
{
  [Guid("9f95b72e-b2ea-3ddf-bee8-66f57321ed22")]
  public class CocoLanguageService : LanguageService
  {
    private LanguagePreferences m_preferences;
    private IScanner m_scanner;
    private CocoSource m_source;
    private CocoPackage m_cocoPack;

    public CocoLanguageService(CocoPackage pack)
    {
      m_cocoPack = pack;
    }

    public override string Name
    {
      get { return "Coco/R Grammar"; }
    }

    public override LanguagePreferences GetLanguagePreferences()
    {
      if (m_preferences == null)
      {
        m_preferences = new LanguagePreferences(Site,
            typeof (CocoLanguageService).GUID, Name);
        m_preferences.Init();
        m_preferences.EnableCommenting = true;
        m_preferences.LineNumbers = true;
      }
      return m_preferences;
    }

    public override IScanner GetScanner(IVsTextLines buffer)
    {
      if (m_scanner == null)
      {
        m_scanner = new CocoScanner();
      }
      return m_scanner;
    }

    public override AuthoringScope ParseSource(ParseRequest req)
    {
      return new CocoAuthoringScope();
    }

    public override Source CreateSource(IVsTextLines buffer)
    {
      m_source = new CocoSource(this, buffer, GetColorizer(buffer));
      return m_source;
    }

    public override string GetFormatFilterList()
    {
      return "*.atg";
    }

    public Source getSource()
    {
      return m_source;
    }
  }
}