﻿using System.Collections;
using System.ComponentModel;
using System.Configuration.Install;
using System.Diagnostics;
using Microsoft.Win32;

namespace CocoSetupAction
{
  [RunInstaller(true)]
  public partial class CocoInstaller : Installer
  {
    private static void DevenvSetup()
    {
      string devenv =
          (string)
              Registry.GetValue(
                  "HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\VisualStudio\\9.0\\Setup\\VS",
                  "EnvironmentPath", "devenv.exe");
      Process proc = Process.Start(devenv, "/setup");
      proc.WaitForExit();
    }

    public CocoInstaller()
    {
      InitializeComponent();
    }

    public override void Install(IDictionary stateSaver)
    {
      base.Install(stateSaver);
      DevenvSetup();
    }

    public override void Uninstall(IDictionary savedState)
    {
      base.Uninstall(savedState);
      DevenvSetup();
    }
  }
}